# 📥 libre-DL
A minimalist GUI wrapper for youtube-dl. Written in python. Total size less than 4 KB. Contributions welcome. You don't need youtube-dl preinstalled in order to use this. 

<h2> Installation: </h2>
1. Download the 'libre-dl.py' file.

2. Make sure you have the package 'tk' (Tkinter) installed. It comes preinstalled with most installations of Python but you can install it like [this](https://tkdocs.com/tutorial/install.html).
 
3. Run 'python3 /Path/To/libre-dl.py'

<h2> What and Why? </h2>
Everybody at some point feels the need to download a video, and currently there are three main options. Using a suspicious looking website to download the videos [which not everyone is comfortable with], installing some proprietary extension and letting unverifiable code run in your browser, or using [youtube-dl](https://youtube-dl.org). 

youtube-dl is by far the best option, but it doesn't have very much adoption outside certain communities, and I believe the main reason for this is because it operates in a command line interface. This could scare away some users. 


While there are other projects like this [mainly [youtube-dl-gui](https://github.com/MrS0m30n3/youtube-dl-gui)], they haven't been updated to reflect the new capabilities of youtube-dl. 


So I built this graphical interface, that is incredibly simple and minimalistic. It has the core options one would need, and more advanced options are being added to it soon. 

<h2> Philosophy </h2>

Quoting the [GNU Project](https://www.gnu.org/philosophy/philosophy.html);

"_Free software means that the software's users have freedom. (The issue is not about price.) ..._

_... Specifically, free software means users have the four essential freedoms: (0) to run the program, (1) to study and change the program in source code form, (2) to redistribute exact copies, and (3) to distribute modified versions._

_Software differs from material objects—such as chairs, sandwiches, and gasoline—in that it can be copied and changed much more easily. These facilities are why software is useful; we believe a program's users should be free to take advantage of them, not solely its developer._"

What they said.

<h2> About code contributions </h2>

ALL, and I repeat ALL, contributions are welcome. If you know how to code, perhaps you could make the code more efficient, fix a bug, develop new logic for the script. If you don't know how to code, maybe you could tell others about this, maybe you could make art for our cover image, or maybe *you could just use it*. 

Even if it's a very insignificant one, I welcome and appreciate all contributions. 

<h2> Future objectives</h2>

There are 3 main objectives for this project;

1. To add options for a slow connection, downloading subtitles, and a persistent record of downloaded videos.

2. To get this script into the main software repositiories, specifically :- [homebrew](brew.sh), [apt](https://wiki.debian.org/Apt), [pip](pypi.org), and the [aur](https://aur.archlinux.org/). 

3. To get over 100 stars on GitHub. I truly see a need for this piece of software, and I want people to know about it. 

<h2>That's all. </h2>
Bye!
